﻿using System;
using System.Collections.Generic;
using System.Text;

namespace SunyruruMabangjin
{
    public class MabangjinBase : SunyruruMabangjin.IMabangjinBase
    {
        /// <summary>
        /// 마방진의 크기
        /// </summary>
        private int size;

        /// <summary>
        /// 마방진의 크기
        /// </summary>
        public int Size
        {
            get { return size; }
            set { size = value; }
        }
        /// <summary>
        /// 마방진 데이터
        /// </summary>
        private int[,] data;

        /// <summary>
        /// 마방진 데이터
        /// </summary>
        public int[,] Data
        {
            get { return data; }
            set { data = value; }
        }

        /// <summary>
        /// 사이즈를 지정한다.
        /// </summary>
        /// <param name="size"></param>
        public void SetSize(int size)
        {
            Size = size;
        }

        /// <summary>
        /// 소멸자
        /// </summary>
        ~MabangjinBase()
        {
        }

        /// <summary>
        /// 마방진 계산
        /// </summary>
        virtual public void Make()
        {
        }

        /// <summary>
        /// 마방진 출력
        /// </summary>
        public void Print()
        {
            for (int i = 0; i < Data.GetLength(0); i++)
            {
                for (int j = 0; j < Data.GetLength(1); j++)
                    Console.Write("{0}\t", Data[i, j]);
                Console.WriteLine();
            }
        }

        /// <summary>
        /// 마방진을 검증한다
        /// </summary>
        public bool Check()
        {
            bool isC = true;
            int checkNum = Size * 2 + 2;
            int[] checks = new int[checkNum];

            for (int i = 0; i < Size; i++)
            {
                for (int j = 0; j < Size; j++)
                {
                    checks[i] += Data[i, j];
                    checks[i + Size] += Data[i, j];
                }
                checks[2 * Size] += Data[i, i];
                checks[2 * Size + 1] += Data[i, Size - 1 - i];
            }

            for (int i = 0; i < checks.Length; i++)
                if (checks[0] != checks[i])
                {
                    isC = false;
                    break;
                }

            return isC;
        }

        /// <summary>
        /// 초기화
        /// </summary>
        virtual public void Init()
        {
            Data = new int[Size, Size];
        }
    }
}
